diff --git a/syntax/namespace.rs b/syntax/namespace.rs
index d26bb9e..a4e972b 100644
--- a/syntax/namespace.rs
+++ b/syntax/namespace.rs
@@ -11,7 +11,7 @@ mod kw {
 
 #[derive(Clone)]
 pub struct Namespace {
-    segments: Vec<String>,
+    pub segments: Vec<String>,
 }
 
 impl Namespace {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 7d92b1b..f5c598d 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -300,6 +300,16 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                             rangle: generic.gt_token,
                         })));
                     }
+                } else if ident == "Vector" && generic.args.len() == 1 {
+                    if let GenericArgument::Type(arg) = &generic.args[0] {
+                        let inner = parse_type(arg)?;
+                        return Ok(Type::Vector(Box::new(Ty1 {
+                            name: ident,
+                            langle: generic.lt_token,
+                            inner,
+                            rangle: generic.gt_token,
+                        })));
+                    }
                 } else if ident == "Box" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg)?;
@@ -310,6 +320,16 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                             rangle: generic.gt_token,
                         })));
                     }
+                } else if ident == "Vec" && generic.args.len() == 1 {
+                    if let GenericArgument::Type(arg) = &generic.args[0] {
+                        let inner = parse_type(arg)?;
+                        return Ok(Type::RustVec(Box::new(Ty1 {
+                            name: ident,
+                            langle: generic.lt_token,
+                            inner,
+                            rangle: generic.gt_token,
+                        })));
+                    }
                 }
             }
             PathArguments::Parenthesized(_) => {}
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 26bb3d1..3d67a0a 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -14,7 +14,9 @@ impl ToTokens for Type {
                 }
                 ident.to_tokens(tokens);
             }
-            Type::RustBox(ty) | Type::UniquePtr(ty) => ty.to_tokens(tokens),
+            Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
+                ty.to_tokens(tokens)
+            }
             Type::Ref(r) | Type::Str(r) | Type::SliceRefU8(r) => r.to_tokens(tokens),
             Type::Slice(s) => s.to_tokens(tokens),
             Type::Fn(f) => f.to_tokens(tokens),
@@ -33,7 +35,8 @@ impl ToTokens for Var {
 
 impl ToTokens for Ty1 {
     fn to_tokens(&self, tokens: &mut TokenStream) {
-        if self.name == "UniquePtr" {
+        // Do not add cxx namespace to Vector since we're defining it in the user crate
+        if self.name == "UniquePtr" || self.name == "RustVec" {
             let span = self.name.span();
             tokens.extend(quote_spanned!(span=> ::cxx::));
         }
diff --git a/syntax/typename.rs b/syntax/typename.rs
new file mode 100644
index 0000000..883e1fb
--- /dev/null
+++ b/syntax/typename.rs
@@ -0,0 +1,36 @@
+use crate::syntax::{Atom, Type};
+
+pub trait ToTypename {
+    fn to_typename(&self, namespace: &Vec<String>) -> String;
+}
+
+impl ToTypename for Type {
+    fn to_typename(&self, namespace: &Vec<String>) -> String {
+        match self {
+            Type::Ident(ident) => {
+                let mut inner = String::new();
+                // Do not apply namespace to built-in type
+                let is_user_type = Atom::from(ident).is_none();
+                if is_user_type {
+                    for name in namespace {
+                        inner += name;
+                        inner += "::";
+                    }
+                }
+                if let Some(ti) = Atom::from(ident) {
+                    inner += ti.to_cxx();
+                } else {
+                    inner += &ident.to_string();
+                };
+                inner
+            }
+            Type::RustBox(ptr) => format!("rust_box<{}>", ptr.inner.to_typename(namespace)),
+            Type::RustVec(ptr) => format!("rust_vec<{}>", ptr.inner.to_typename(namespace)),
+            Type::UniquePtr(ptr) => {
+                format!("std::unique_ptr<{}>", ptr.inner.to_typename(namespace))
+            }
+            Type::Vector(ptr) => format!("std::vector<{}>", ptr.inner.to_typename(namespace)),
+            _ => unimplemented!(),
+        }
+    }
+}
diff --git a/syntax/types.rs b/syntax/types.rs
index 6f3af09..7bce154 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -24,7 +24,9 @@ impl<'a> Types<'a> {
             all.insert(ty);
             match ty {
                 Type::Ident(_) | Type::Str(_) | Type::Void(_) | Type::SliceRefU8(_) => {}
-                Type::RustBox(ty) | Type::UniquePtr(ty) => visit(all, &ty.inner),
+                Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
+                    visit(all, &ty.inner)
+                }
                 Type::Ref(r) => visit(all, &r.inner),
                 Type::Slice(s) => visit(all, &s.inner),
                 Type::Fn(f) => {
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index efdd1fa..da0040a 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -27,6 +27,9 @@ pub mod ffi {
         fn c_return_sliceu8(shared: &Shared) -> &[u8];
         fn c_return_rust_string() -> String;
         fn c_return_unique_ptr_string() -> UniquePtr<CxxString>;
+        fn c_return_unique_ptr_vector_u8() -> UniquePtr<Vector<u8>>;
+        fn c_return_unique_ptr_vector_f64() -> UniquePtr<Vector<f64>>;
+        fn c_return_unique_ptr_vector_shared() -> UniquePtr<Vector<Shared>>;
 
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
@@ -38,6 +41,11 @@ pub mod ffi {
         fn c_take_sliceu8(s: &[u8]);
         fn c_take_rust_string(s: String);
         fn c_take_unique_ptr_string(s: UniquePtr<CxxString>);
+        fn c_take_unique_ptr_vector_u8(s: UniquePtr<Vector<u8>>);
+        fn c_take_unique_ptr_vector_f64(s: UniquePtr<Vector<f64>>);
+        fn c_take_unique_ptr_vector_shared(s: UniquePtr<Vector<Shared>>);
+        fn c_take_vec_u8(v: &Vec<u8>);
+        fn c_take_vec_shared(v: &Vec<Shared>);
         fn c_take_callback(callback: fn(String) -> usize);
 
         fn c_try_return_void() -> Result<()>;
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 619485a..a8d7018 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -1,6 +1,7 @@
 #include "tests/ffi/tests.h"
 #include "tests/ffi/lib.rs.h"
 #include <cstring>
+#include <numeric>
 #include <stdexcept>
 
 extern "C" void cxx_test_suite_set_correct() noexcept;
@@ -57,6 +58,32 @@ std::unique_ptr<std::string> c_return_unique_ptr_string() {
   return std::unique_ptr<std::string>(new std::string("2020"));
 }
 
+std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8() {
+  auto retval =
+      std::unique_ptr<std::vector<uint8_t>>(new std::vector<uint8_t>());
+  retval->push_back(86);
+  retval->push_back(75);
+  retval->push_back(30);
+  retval->push_back(9);
+  return retval;
+}
+
+std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64() {
+  auto retval = std::unique_ptr<std::vector<double>>(new std::vector<double>());
+  retval->push_back(86.0);
+  retval->push_back(75.0);
+  retval->push_back(30.0);
+  retval->push_back(9.5);
+  return retval;
+}
+
+std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared() {
+  auto retval = std::unique_ptr<std::vector<Shared>>(new std::vector<Shared>());
+  retval->push_back(Shared{1010});
+  retval->push_back(Shared{1011});
+  return retval;
+}
+
 void c_take_primitive(size_t n) {
   if (n == 2020) {
     cxx_test_suite_set_correct();
@@ -118,6 +145,43 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s) {
   }
 }
 
+void c_take_unique_ptr_vector_u8(std::unique_ptr<std::vector<uint8_t>> v) {
+  if (v->size() == 4) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_unique_ptr_vector_f64(std::unique_ptr<std::vector<double>> v) {
+  if (v->size() == 4) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_unique_ptr_vector_shared(std::unique_ptr<std::vector<Shared>> v) {
+  if (v->size() == 2) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_vec_u8(const ::rust::Vec<uint8_t> &v) {
+  auto cv = static_cast<std::vector<uint8_t>>(v);
+  uint8_t sum = std::accumulate(cv.begin(), cv.end(), 0);
+  if (sum == 200) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_vec_shared(const ::rust::Vec<Shared> &v) {
+  auto cv = static_cast<std::vector<Shared>>(v);
+  uint32_t sum = 0;
+  for (auto i : cv) {
+    sum += i.z;
+  }
+  if (sum == 2021) {
+    cxx_test_suite_set_correct();
+  }
+}
+
 void c_take_callback(rust::Fn<size_t(rust::String)> callback) {
   callback("2020");
 }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index ed6d541..876e3c5 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -29,6 +29,9 @@ rust::Str c_return_str(const Shared &shared);
 rust::Slice<uint8_t> c_return_sliceu8(const Shared &shared);
 rust::String c_return_rust_string();
 std::unique_ptr<std::string> c_return_unique_ptr_string();
+std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8();
+std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64();
+std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared();
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);
@@ -40,6 +43,11 @@ void c_take_str(rust::Str s);
 void c_take_sliceu8(rust::Slice<uint8_t> s);
 void c_take_rust_string(rust::String s);
 void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
+void c_take_unique_ptr_vector_u8(std::unique_ptr<std::vector<uint8_t>> v);
+void c_take_unique_ptr_vector_f64(std::unique_ptr<std::vector<double>> v);
+void c_take_unique_ptr_vector_shared(std::unique_ptr<std::vector<Shared>> v);
+void c_take_vec_u8(const ::rust::Vec<uint8_t> &v);
+void c_take_vec_shared(const ::rust::Vec<Shared> &v);
 void c_take_callback(rust::Fn<size_t(rust::String)> callback);
 
 void c_try_return_void();
diff --git a/tests/test.rs b/tests/test.rs
index 1cd85df..b33c675 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -32,6 +32,45 @@ fn test_c_return() {
     assert_eq!(b"2020\0", ffi::c_return_sliceu8(&shared));
     assert_eq!("2020", ffi::c_return_rust_string());
     assert_eq!("2020", ffi::c_return_unique_ptr_string().to_str().unwrap());
+    assert_eq!(
+        4,
+        ffi::c_return_unique_ptr_vector_u8()
+            .as_ref()
+            .unwrap()
+            .size()
+    );
+    assert_eq!(
+        200_u8,
+        ffi::c_return_unique_ptr_vector_u8()
+            .as_ref()
+            .unwrap()
+            .into_iter()
+            .sum()
+    );
+    assert_eq!(
+        200.5_f64,
+        ffi::c_return_unique_ptr_vector_f64()
+            .as_ref()
+            .unwrap()
+            .into_iter()
+            .sum()
+    );
+    assert_eq!(
+        2,
+        ffi::c_return_unique_ptr_vector_shared()
+            .as_ref()
+            .unwrap()
+            .size()
+    );
+    assert_eq!(
+        2021_usize,
+        ffi::c_return_unique_ptr_vector_shared()
+            .as_ref()
+            .unwrap()
+            .into_iter()
+            .map(|o| o.z)
+            .sum()
+    );
 }
 
 #[test]
@@ -65,6 +104,20 @@ fn test_c_take() {
     check!(ffi::c_take_unique_ptr_string(
         ffi::c_return_unique_ptr_string()
     ));
+    check!(ffi::c_take_unique_ptr_vector_u8(
+        ffi::c_return_unique_ptr_vector_u8()
+    ));
+    check!(ffi::c_take_unique_ptr_vector_f64(
+        ffi::c_return_unique_ptr_vector_f64()
+    ));
+    check!(ffi::c_take_unique_ptr_vector_shared(
+        ffi::c_return_unique_ptr_vector_shared()
+    ));
+    check!(ffi::c_take_vec_u8(&[86_u8, 75_u8, 30_u8, 9_u8].to_vec()));
+    check!(ffi::c_take_vec_shared(&vec![
+        ffi::Shared { z: 1010 },
+        ffi::Shared { z: 1011 }
+    ]));
 }
 
 #[test]

